<?php error_reporting(0); /* Name: ajax.php - PHP Functions for AJAX Author: Vinay Babu Reddy Date: 15 Apr 2013 */ /* Verfication */ if (!$ipaddr = (isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : false)) exit("NOK"); if (!isset($_COOKIE['SESSID'])) { setSession(); writeLog("ALERT","!! NEW SESSION !!"); } else { $sessid = $_COOKIE['SESSID']; } $tokenfile = "_session/token_${sessid}_${ipaddr}"; if (!$action = (isset($_GET['action']) ? $_GET['action'] : false)) exit("NOK"); switch($action) { case 'doLock': if (file_exists($tokenfile) && unlink($tokenfile)) { setSession(); writeLog("DEBUG","Locked OK"); exit("LOCK"); } else { writeLog("WARN","Locked NOK"); exit("NOK"); } break; case 'unLock': if (!$lockpswd = file_get_contents('php://input')) exit("NOK"); if (unLock($lockpswd,'')) { writeLog("DEBUG","Unlock OK"); exit("UNLK"); } else { writeLog("WARN","Unlock NOK"); exit("NOK"); } break; case 'resetPswd': if (!$lockpswd = file_get_contents('php://input')) exit("NOK"); if (!$lockpswds = explode("|",$lockpswd)) exit("NOK"); if (unLock($lockpswds[0],$lockpswds[1])) { writeLog("DEBUG","Resets OK"); exit("OK"); } else { writeLog("WARN","Resets NOK"); exit("NOK"); } break; } if (!file_exists($tokenfile)) { setSession(); writeLog("DEBUG","Access NOK"); exit("LOCK"); } else if ($action == 'getFile') { writeLog("DEBUG","Access OK"); exit("FILE"); } /* File Management */ if (!$urlpath = urlPath('path')) exit("NOK"); if (!$dirtype = dirType($urlpath)) exit("NOK"); if (!preChecks()) exit("NOK"); switch($action) { case 'getList': $sname = (isset($_GET['sname']) ? $_GET['sname'] : ''); if ($listvalue = getList($urlpath,$sname)) { if (!$sname) writeLog("DEBUG","Access OK '${urlpath}'"); else writeLog("DEBUG","Search OK '$sname' in '${urlpath}'"); exit("DIR${listvalue}"); } else { if (!$sname) writeLog("WARN","Access NOK '${urlpath}'"); else writeLog("WARN","Search NOK '$sname' in '${urlpath}'"); exit("NOK"); } break; case 'getDoc': if ($filecontent = getDoc($urlpath)) { writeLog("DEBUG","Access OK '${urlpath}'"); exit("DOC$filecontent"); } else { writeLog("WARN","Access NOK '${urlpath}'"); exit("NOK"); } break; case 'saveFile': if (saveFile($urlpath)) { writeLog("INFO","Writes OK '${urlpath}'"); exit("OK"); } else { writeLog("ERROR","Writes NOK '${urlpath}'"); exit("NOK"); } break; case 'createDir': if (createDir($urlpath,'N')) { writeLog("INFO","Create OK '${urlpath}'"); exit("OK"); } else { writeLog("ERROR","Create NOK '${urlpath}'"); exit("NOK"); } break; case 'deleteObj': if (deleteObj($urlpath,'N')) { writeLog("INFO","Delete OK '${urlpath}'"); exit("OK"); } else { writeLog("ERROR","Delete NOK '${urlpath}'"); exit("NOK"); } break; case 'renameObj': if (!$newpath = urlPath('newpath')) exit("NOK"); if (renameObj($urlpath,$newpath,'N')) { writeLog("INFO","Rename OK '${urlpath}' to '${newpath}'"); exit("OK"); } else { writeLog("ERROR","Rename NOK '${urlpath}' to '${newpath}'"); exit("NOK"); } break; case 'uploadFile': if (uploadFile($urlpath)) { writeLog("INFO","Upload OK '${urlpath}'"); exit("OK"); } else { writeLog("ERROR","Upload NOK '${urlpath}'"); exit("NOK"); } break; } ?>
<?php /* Name: auth.php - PHP Functions for Authentication and Authorization Author: Vinay Babu Reddy Date: 15 Apr 2013 */ /* Unlock */ function unLock($lockpswd,$newpswd) { if (!$lockpswd) return false; global $sessid, $tokenfile; $trycount = (isset($_COOKIE['X']) ? $_COOKIE['X'] : 1); if ($trycount > 5) return false; $lockfile = "_session/.lockp"; if (!is_file($lockfile)) return false; $filepswd = file_get_contents($lockfile); if (!$filepswd = hash("sha256","${filepswd}:${sessid}")) return false; if ($lockpswd == $filepswd) { if ($newpswd) file_put_contents($lockfile,$newpswd); else file_put_contents($tokenfile,'OK'); if ($trycount > 1) setcookie('X',1,time()+(60*60*24*30)); return true; } else { if (file_exists($tokenfile)) unlink($tokenfile); setcookie('X',($trycount + 1),time()+(60*60*24*30)); return false; } } function setSession() { $sessid = uniqid().rand(); $nodays = 60 * 60 * 24 * 30; setcookie('SESSID',$sessid,time()+$nodays); foreach (glob("_session/token_*") as $filename) if (filemtime($filename) < time()-$nodays) unlink($filename); } /* Prechecks */ function urlPath($path) { if (!$path || !isset($_GET[$path])) return false; $urlpath = $_GET[$path]; if (!$urlpath = preg_replace('/\/+/','/',$urlpath)) return false; if (!$urlpath = str_replace('\\','',$urlpath)) return false; if (!$urlpath = preg_replace('/[[:blank:]]+/',' ',$urlpath)) return false; if ($urlpath) return $urlpath; else return false; } function dirType($urlpath) { if (!$urlpath) return false; if ($dirtypes = explode("/",$urlpath)) return $dirtypes[0]; else return false; } function preChecks() { global $urlpath, $dirtype; if ($dirtype != 'Documents' && $dirtype != 'Music' && $dirtype != 'Photos') return false; if (preg_match('/(\.\.)/',$urlpath)) return false; if (is_dir(dirname($urlpath))) return true; else return false; } /* Logging */ function writeLog($logtype,$logmsg) { if (!$logtype || !$logmsg) return false; if ($logtype == 'DEBUG') return true; /*if ($logtype == 'INFO') return true;*/ /*if ($logtype == 'WARN') return true;*/ /*if ($logtype == 'ERROR') return true;*/ date_default_timezone_set('Asia/Kolkata'); global $ipaddr; $logfile = "activity.log"; $logtime = date("Ymd His"); if ($fa = fopen($logfile,"a")) { fwrite($fa,"$logtime ".str_pad($ipaddr,15," ")." - [".str_pad($logtype,5," ")."] $logmsg\n"); fclose($fa); } } ?>
<?php /*  Name: display.php - Display Functions Library  Author: Vinay Babu Reddy  Date: 15 Apr 2013 */  /* Generate Browser List */ function getList($dirname,$sname) {  if (!$dirname) return false;  if (!is_dir($dirname)) return false;  if ($dir = scandir($dirname)) {  $listvalue = "";  $i = 0; $j = 0;  foreach ($dir as $fname) {  if ($fname != "." && $fname != ".." && $fname != "thumbs" && $fname != "private") {  $filename = "${dirname}/${fname}";  if ($sname) {  if (preg_match("/${sname}/i","$fname")) $listvalue .= displayList($dirname,array($fname));  if (is_dir($filename)) $listvalue .= getList("$filename",$sname);  } else {  if (is_dir($filename)) {  $dirlists[$i] = $fname;  $i++;  } else if (is_file($filename)) {  $filelists[$j] = $fname;  $j++;  }  }  }  }  if ($i > 0) $listvalue .= displayList($dirname,$dirlists);  if ($j > 0) $listvalue .= displayList($dirname,$filelists);  if ($listvalue) return $listvalue;  else if (!$sname) return true;  } else {  return false;  } }  /* Display Directory List */ function displayList($dirname,$lists) {  if (!$dirname || !$lists) return false;  global $dirtype;  $listvalue = "";  date_default_timezone_set('Asia/Kolkata');  sort($lists);  foreach ($lists as $fname) {  $filename = "${dirname}/${fname}";  $size = filesize($filename);  $size = round($size/1024,0);  $date = date("Ymd",filemtime($filename));  if (is_dir($filename)) {  $ftype = 'dir';  } else {  if ($dirtype == 'Music' || $dirtype == 'Photos') createThumbFile($filename);  $ftype = $dirtype;  }  $listvalue .= "${dirname}|${fname}|${size}|${date}|${ftype}$\n";  }  return $listvalue; }  /* get Thumbnail file */ function thumbFile($filename) {  if (!$filename) return false;  global $dirtype;  if ($dirtype == 'Music' || $dirtype == 'Photos') {  if (!$fname = pathinfo($filename,PATHINFO_FILENAME)) return false;  if (!$dirname = dirname($filename)) return false;  return "${dirname}/thumbs/${fname}.jpg";  } } ?>
<?php /*  Name: actions.php - Action Functions Library  Author: Vinay Babu Reddy  Date: 15 Apr 2013 */  /* File Name Check */ function nameCheck($filename,$ftype) {  if (!$filename || !$ftype) return false;  global $dirtype;  if ($dirtype == 'Documents') $extn = '(html|txt|hdoc|pdf|zip|doc|xls|ppt|docx|xlsx|pptx|mp4|ogv)';  else if ($dirtype == 'Music') $extn = '(mp3|ogg)';  else if ($dirtype == 'Photos') $extn = '(jpg|png|gif)';  $pattern = '[a-z0-9][a-z0-9\ _\.\'\-\(\)]+';  if ($ftype == 'file') $pattern = "${pattern}.${extn}";  if (!$fname = basename($filename)) return false;  if (preg_match("/^${pattern}$/i",$fname)) return true;  else return false; }  /* Create Directory */ function createDir($dirname,$isthumb) {  if (!$dirname || !$isthumb) return false;  if (file_exists($dirname)) return false;  global $dirtype;  if (!nameCheck($dirname,'dir')) return false;  if (mkdir($dirname)) {  chmod($dirname,0777);  if (($isthumb == 'N') && ($dirtype == 'Music' || $dirtype == 'Photos')) createDir("$dirname/thumbs",'Y');  return true;  } else {  return false;  } }  /* Rename Objects */ function renameObj($origname,$destname,$isthumb) {  if (!$origname || !$destname || !$isthumb) return false;  if ($origname == $destname) return false; if (!file_exists($origname)) return false;  if (file_exists($destname)) return false;  global $dirtype;  if ($isthumb == 'N') {  if (is_file($origname) && !nameCheck($destname,'file')) return false;  else if (is_dir($origname) && !nameCheck($destname,'dir')) return false;  }  if (rename($origname,$destname)) {  if (is_file($destname)) {  if (($isthumb == 'N') && ($dirtype == 'Music' || $dirtype == 'Photos')) renameObj(thumbFile($origname),thumbFile($destname),'Y');  }  return true;  } else {  return false;  } }  /* Delete Objects */ function deleteObj($filename,$isthumb) {  if (!$filename || !$isthumb) return false;  if (!file_exists($filename)) return false;  global $dirtype;  if (is_file($filename) && unlink($filename)) {  if ($isthumb == 'N' && ($dirtype == 'Music' || $dirtype == 'Photos')) deleteObj(thumbFile($filename),'Y');  return true;  } else if (is_dir($filename) && rrmdir($filename)) {  return true;  } else {  return false;  } } function rrmdir($dirname) {  if (!$dirname) return false;  if (!is_dir($dirname)) return false;  if ($dir = scandir($dirname)) {  foreach ($dir as $fname) {  if ($fname != "." && $fname != "..") {  $filename = "${dirname}/${fname}";  if (is_file($filename) && !unlink($filename)) return false;  else if (is_dir($filename) && !rrmdir($filename)) return false;  }  }  }  if (rmdir($dirname)) return true;  else return false; }  /* Upload Files */ function uploadFile($filename) {  if (!$filename) return false;  if (file_exists($filename)) return false;  global $dirtype;  if (!nameCheck($filename,'file')) return false;  if (!$sourcefile = file_get_contents('php://input')) return false;  if ($sourcefile && file_put_contents($filename,$sourcefile)) {  chmod($filename,0666);  if ($dirtype == 'Music' || $dirtype == 'Photos') createThumbFile($filename);  return true;  } else {  return false;  } }  /* display FILE Content */ function getDoc($filename) {  if (!$filename) return false;  if (!is_file($filename)) return false;  if ($filecontent = file_get_contents("$filename")) return $filecontent;  else return false; }  /* Edit FILE Files */ function saveFile($filename) {  if (!$filename) return false;  $filecontent = "<p>New doc</p>";  if (!nameCheck($filename,'file')) return false;  if (is_file($filename) && !$filecontent = file_get_contents('php://input')) return false;  if ($filecontent && file_put_contents($filename,"${filecontent}")) {  chmod($filename,0666);  return true;  } else {  return false;  } } ?>
<?php /* Name: thumbnails.php - Thumbnail Functions Library Author: Vinay Babu Reddy Date: 15 Apr 2013 */ /* Generate Thumbnail */ function createThumbFile($filename) { if (!$filename) return false; if (!is_file($filename)) return false; global $dirtype; if ($dirtype == 'Music' || $dirtype == 'Photos') { $thumbfile = thumbFile($filename); if (!$thumbfile) return false; if (!file_exists($thumbfile)) { if (!$dirname = dirname($filename)) return false; if (!is_dir("${dirname}/thumbs") && !createDir("${dirname}/thumbs",'Y')) return false; if ($dirtype == 'Music') { if (!$fname = pathinfo($filename,PATHINFO_FILENAME)) return false; if (!$topic = str_replace(" ","+",$fname)) return false; if (!$filename = googleImage($topic)) { if (!$filename = googleImage("${topic}+album")) return false; } } if (resizeImg($filename,$thumbfile,40,40)) return true; else return false; } } } /* Create Images */ function resizeImg($filename,$destname,$twidth,$theight) { if (!$filename || !$destname) return false; $maxsize = 5000; if (!$size = GetImageSize($filename)) return false; $width = $size[0]; $height = $size[1]; if (!$width || !$height) return false; if ($width >= $maxsize || $height >= $maxsize) return false; if (($width / $height) > 1) { $cwidth = $width / ($height / $theight); $cheight = $theight; } else { $cwidth = $twidth; $cheight = $height / ($width / $twidth); } if (!$cwidth || !$cheight) return false; if (!$extn = strtolower(pathinfo($filename,PATHINFO_EXTENSION))) return false; if (($extn == 'jpg' || $extn == 'jpeg') && !$origname = ImageCreateFromJPEG($filename)) return false; else if ($extn == 'png' && !$origname = ImageCreateFromPNG($filename)) return false; else if ($extn == 'gif' && !$origname = ImageCreateFromGIF($filename)) return false; if (!$origname) return false; if (!$tempname = ImageCreateTrueColor($twidth,$theight)) return false; if (!ImageCopyResampled($tempname,$origname, 0 - ($cwidth / 2 - $twidth / 2),0 - ($cheight / 2 - $theight / 2), 0,0,$cwidth,$cheight,$width,$height)) return false; if (!ImageJpeg($tempname,$destname)) return false; ImageDestroy($origname); ImageDestroy($tempname); chmod($destname,0666); return true; } /* Get Pictures from Google */ function googleImage($topic) { if (!$topic) return false; if (!$randnum = rand(1,9)) return false; $geturl = "http://www.google.com/search?q=${topic}+${randnum}&gbv=2&tbm=isch"; if (!validURL($geturl)) return false; if (!$fullpage = file_get_contents($geturl)) return false; $find1 = '<div id="center_col">'; $find2 = '<a href="/imgres?imgurl='; $find3 = '&amp;imgrefurl='; if (!$pos1 = strpos($fullpage,$find1)+strlen($find1)) return false; if (!$pos2 = strpos($fullpage,$find2,$pos1)+strlen($find2)) return false; if (!$pos3 = strpos($fullpage,$find3,$pos2)) return false; if (!$imgurl = substr($fullpage,$pos2,$pos3-$pos2)) return false; if (!$imgurl = str_replace("%2520","%20",$imgurl)) return false; if (validURL($imgurl)) return $imgurl; else return false; } /* Check for Valid URL */ function validURL($urlname) { if (!$urlname) return false; if (!$urlheaders = get_headers($urlname)) return false; if (!$httpstatus = explode(' ',$urlheaders[0])) return false; if ($httpstatus[1] == '200') return true; else return false; } ?>
